<?php

namespace App\Http\Controllers;

use App\Models\Unit;
use Illuminate\Http\Request;

class UnityController extends Controller
{
    /**
     * Liste des unités.
     */
    public function index()
    {
        $units = Unit::withCount('products')->orderBy('created_at', 'desc')->paginate(10);
        return view('units.index', compact('units'));
    }

    /**
     * Ajout d'une unité.
     */
    public function store(Request $request)
    {
        $validated = $request->validate([
            'name' => 'required|string|max:255',
            'abbreviation' => 'required|string|max:15|unique:units,abbreviation',
            'description' => 'nullable|string|max:155',
        ]);

        Unit::create($validated);
        return redirect()->route('units.index')->with('success', 'Unité créée avec succès');
    }

    /**
     * Mise à jour de l'unité
     */
    public function update(Request $request, string $id)
    {
        $unit = Unit::findOrFail($id);

        $validated = $request->validate([
            'name' => 'required|string|max:255',
            'abbreviation' => 'required|string|max:15|unique:units,abbreviation,' . $unit->id,
            'description' => 'nullable|string|max:155',
        ]);

        $unit->update($validated);
        return redirect()->route('units.index')->with('success', 'Unité modifiée avec succès');
    }

    /**
     * Suppression de l'unité
     */
    public function destroy(string $id)
    {
        //Si l'unité n'existe pas affiche une erreur 
        $unit = Unit::findOrFail($id);
        $unit->delete();
        return redirect()->route('units.index')->with('success', 'Unité supprimée avec succès');
    }
}